import ts from 'rollup-plugin-typescript'
import resolve from 'rollup-plugin-node-resolve'
import commonjs from 'rollup-plugin-commonjs'

import typescript from 'typescript'
import pkg from './package.json'

const external = Object.keys(pkg.dependencies || {})

export default [
  {
    name: 'reactPowerPlug',
    input: './src/index.tsx',
    external,
    output: {
      file: pkg.browser,
      format: 'umd',
    },
    globals: {
      react: 'React',
    },
		plugins: [
			ts({ typescript }),
			resolve(), // so Rollup can find `ms`
			commonjs(), // so Rollup can convert `ms` to an ES module
		],
  },
  {
    input: './src/index.tsx',
    output: [
      { file: pkg.main, format: 'cjs' },
      { file: pkg.module, format: 'es' }
    ],
    external,

    plugins: [
			ts({ typescript }),
    ],
  },
]
