import React from 'react'

export type CounterChildrenFn = {
  count: number,
  add: (ammount: number) => any,
  increment: () => any,
  decrement: () => any,
}

export type CounterProps = {
  children: (f: CounterChildrenFn) => JSX.Element | null,
  default?: number,
}

export type CounterState = {
  count: number,
}

class Counter extends React.PureComponent<CounterProps, CounterState> {
  state = {
    count: typeof this.props.default === 'number'
      ? this.props.default
      : 0,
  }

  add = (ammount: number) =>
    this.setState(state => ({
      count: state.count + ammount,
    }))

  increment = () => this.add(1)
  decrement = () => this.add(-1)

  render() {
    return this.props.children({
      count: this.state.count,
      increment: this.increment,
      decrement: this.decrement,
      add: this.add,
    })
  }
}

export default Counter
